Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/domain.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/domain.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/domain.F90	(revision 10001)
@@ -78,5 +78,4 @@
       CHARACTER (len=*), INTENT(IN) :: cdstr                  ! model: NEMO or SAS. Determines core restart variables
       INTEGER , DIMENSION(jpi,jpj) ::   ik_top , ik_bot       ! top and bottom ocean level
-      REAL(wp), DIMENSION(jpi,jpj) ::   z1_hu_0, z1_hv_0
       !!----------------------------------------------------------------------
       !
@@ -138,48 +137,51 @@
       CALL dom_msk( ik_top, ik_bot )   ! Masks
       IF( ln_closea )   CALL dom_clo   ! ln_closea=T : closed seas included in the simulation
-                                       ! Read in masks to define closed seas and lakes 
+      !                                ! Read in masks to define closed seas and lakes 
       !
       DO jj = 1, jpj                   ! depth of the iceshelves
          DO ji = 1, jpi
             ik = mikt(ji,jj)
-            risfdep(ji,jj) = gdepw_0(ji,jj,ik)
+            risfdep(ji,jj) = gdepw_0(ji,jj,ik)        !!gm  RENAME it as h_isf(:,:)  better no?
          END DO
       END DO
       !
-      ht_0(:,:) = 0._wp  ! Reference ocean thickness
-      hu_0(:,:) = 0._wp
+      ht_0(:,:) = 0._wp  ! Reference water column thickness  (wet point only, i.e. without ISF thickness
+      hu_0(:,:) = 0._wp  !           ------------                                  and zero over land    )    
       hv_0(:,:) = 0._wp
+      hf_0(:,:) = 0._wp
       DO jk = 1, jpk
          ht_0(:,:) = ht_0(:,:) + e3t_0(:,:,jk) * tmask(:,:,jk)
          hu_0(:,:) = hu_0(:,:) + e3u_0(:,:,jk) * umask(:,:,jk)
          hv_0(:,:) = hv_0(:,:) + e3v_0(:,:,jk) * vmask(:,:,jk)
+         hf_0(:,:) = hf_0(:,:) + e3f_0(:,:,jk) * fmask(:,:,jk)
       END DO
       !
+      r1_ht_0(:,:) =  ssmask(:,:) / ( ht_0(:,:) + 1._wp -  ssmask(:,:) )    ! =0 on lands
+      r1_hu_0(:,:) = ssumask(:,:) / ( hu_0(:,:) + 1._wp - ssumask(:,:) )    ! not in ISF areas
+      r1_hv_0(:,:) = ssvmask(:,:) / ( hv_0(:,:) + 1._wp - ssvmask(:,:) )
+      r1_hf_0(:,:) = ssfmask(:,:) / ( hf_0(:,:) + 1._wp - ssfmask(:,:) )
+      !
       !           !==  time varying part of coordinate system  ==!
       !
       IF( ln_linssh ) THEN       != Fix in time : set to the reference one for all
-      !
-         !       before        !          now          !       after         !
-            gdept_b = gdept_0  ;   gdept_n = gdept_0   !        ---          ! depth of grid-points
-            gdepw_b = gdepw_0  ;   gdepw_n = gdepw_0   !        ---          !
-                                   gde3w_n = gde3w_0   !        ---          !
-         !                                                                  
-              e3t_b =   e3t_0  ;     e3t_n =   e3t_0   ;   e3t_a =  e3t_0    ! scale factors
-              e3u_b =   e3u_0  ;     e3u_n =   e3u_0   ;   e3u_a =  e3u_0    !
-              e3v_b =   e3v_0  ;     e3v_n =   e3v_0   ;   e3v_a =  e3v_0    !
-                                     e3f_n =   e3f_0   !        ---          !
-              e3w_b =   e3w_0  ;     e3w_n =   e3w_0   !        ---          !
-             e3uw_b =  e3uw_0  ;    e3uw_n =  e3uw_0   !        ---          !
-             e3vw_b =  e3vw_0  ;    e3vw_n =  e3vw_0   !        ---          !
-         !
-         z1_hu_0(:,:) = ssumask(:,:) / ( hu_0(:,:) + 1._wp - ssumask(:,:) )     ! _i mask due to ISF
-         z1_hv_0(:,:) = ssvmask(:,:) / ( hv_0(:,:) + 1._wp - ssvmask(:,:) )
-         !
-         !        before       !          now          !       after         !
-                                      ht_n =    ht_0   !                     ! water column thickness
-               hu_b =    hu_0  ;      hu_n =    hu_0   ;    hu_a =    hu_0   ! 
-               hv_b =    hv_0  ;      hv_n =    hv_0   ;    hv_a =    hv_0   !
-            r1_hu_b = z1_hu_0  ;   r1_hu_n = z1_hu_0   ; r1_hu_a = z1_hu_0   ! inverse of water column thickness
-            r1_hv_b = z1_hv_0  ;   r1_hv_n = z1_hv_0   ; r1_hv_a = z1_hv_0   !
+         !
+         !    before         !          now          !       after         !
+         gdept_b = gdept_0   ;   gdept_n = gdept_0   !        ---          !    depth 
+         gdepw_b = gdepw_0   ;   gdepw_n = gdepw_0   !        ---          !     of
+                                 gde3w_n = gde3w_0   !        ---          ! grid-points
+         !                   !                       !                     !                                              
+          e3t_b  =   e3t_0   ;     e3t_n =   e3t_0   ;   e3t_a =  e3t_0    !  scale 
+          e3u_b  =   e3u_0   ;     e3u_n =   e3u_0   ;   e3u_a =  e3u_0    ! factors
+          e3v_b  =   e3v_0   ;     e3v_n =   e3v_0   ;   e3v_a =  e3v_0    !
+                                   e3f_n =   e3f_0   !        ---          !
+          e3w_b  =   e3w_0   ;     e3w_n =   e3w_0   !        ---          !
+         e3uw_b  =  e3uw_0   ;    e3uw_n =  e3uw_0   !        ---          !
+         e3vw_b  =  e3vw_0   ;    e3vw_n =  e3vw_0   !        ---          !
+         !                   !
+                                    ht_n =    ht_0   !                     ! water column
+            hu_b =    hu_0   ;      hu_n =    hu_0   ;    hu_a =    hu_0   !  thickness
+            hv_b =    hv_0   ;      hv_n =    hv_0   ;    hv_a =    hv_0   !
+         r1_hu_b = r1_hu_0   ;   r1_hu_n = r1_hu_0   ; r1_hu_a = r1_hu_0   ! 1 / water column
+         r1_hv_b = r1_hv_0   ;   r1_hv_n = r1_hv_0   ; r1_hv_a = r1_hv_0   !       thickness
          !
          !
@@ -192,9 +194,9 @@
       IF( lk_c1d         )   CALL cor_c1d       ! 1D configuration: Coriolis set at T-point
       !
-      IF( ln_meshmask .AND. .NOT.ln_iscpl )                        CALL dom_wri     ! Create a domain file
+      IF( ln_meshmask .AND. .NOT.ln_iscpl                      )   CALL dom_wri     ! Create a domain file
       IF( ln_meshmask .AND.      ln_iscpl .AND. .NOT.ln_rstart )   CALL dom_wri     ! Create a domain file
       IF(                                       .NOT.ln_rstart )   CALL dom_ctl     ! Domain control
       !
-      IF( ln_write_cfg )   CALL cfg_write         ! create the configuration file
+      IF( ln_write_cfg )   CALL cfg_write       ! create the configuration file
       !
       IF(lwp) THEN
@@ -204,5 +206,5 @@
          WRITE(numout,*) 
       ENDIF
-      !
+       !
    END SUBROUTINE dom_init
 
@@ -290,8 +292,8 @@
       NAMELIST/namrun/ cn_ocerst_indir, cn_ocerst_outdir, nn_stocklist, ln_rst_list,                   &
          &             nn_no   , cn_exp   , cn_ocerst_in, cn_ocerst_out, ln_rstart , nn_rstctl   ,     &
-         &             nn_it000, nn_itend , nn_date0    , nn_time0     , nn_leapy  , nn_istate   ,     &
+         &             nn_it000, nn_itend , nn_date0    , nn_time0     , nn_leapy  , ln_istate   ,     &
          &             nn_stock, nn_write , ln_mskland  , ln_clobber   , nn_chunksz, ln_1st_euler,     &
          &             ln_cfmeta, ln_iscpl, ln_xios_read, nn_wxios
-      NAMELIST/namdom/ ln_linssh, rn_isfhmin, rn_Dt, rn_atfp, ln_crs, ln_meshmask
+      NAMELIST/namdom/ ln_RK3, ln_MLF, rn_Dt, rn_atfp, ln_linssh, rn_isfhmin, ln_crs, ln_meshmask
 #if defined key_netcdf4
       NAMELIST/namnc4/ nn_nchunks_i, nn_nchunks_j, nn_nchunks_k, ln_nc4zip
@@ -305,4 +307,33 @@
       ENDIF
       !
+      REWIND( numnam_ref )              ! Namelist namdom in reference namelist : space & time domain (bathymetry, mesh, timestep)
+      READ  ( numnam_ref, namdom, IOSTAT = ios, ERR = 903)
+903   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namdom in reference namelist', lwp )
+      REWIND( numnam_cfg )              ! Namelist namdom in configuration namelist : space & time domain (bathymetry, mesh, timestep)
+      READ  ( numnam_cfg, namdom, IOSTAT = ios, ERR = 904 )
+904   IF( ios >  0 )   CALL ctl_nam ( ios , 'namdom in configuration namelist', lwp )
+      IF(lwm) WRITE( numond, namdom )
+      !
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) '   Namelist : namdom   ---   space & time domain'
+         WRITE(numout,*) '      3rd order Runge-Kutta scheme            ln_RK3      = ', ln_RK3
+         WRITE(numout,*) '      Modified Leap-Frog    scheme            ln_MLF      = ', ln_MLF
+         WRITE(numout,*) '         asselin time filter parameter           rn_atfp  = ', rn_atfp
+         WRITE(numout,*) '      ocean time step (RK3 & MLF)             rn_Dt       = ', rn_Dt
+         WRITE(numout,*) '      linear free surface (=T)                ln_linssh   = ', ln_linssh
+         WRITE(numout,*) '      create mesh/mask file                   ln_meshmask = ', ln_meshmask
+         WRITE(numout,*) '      treshold to open the isf cavity         rn_isfhmin  = ', rn_isfhmin, ' [m]'
+         WRITE(numout,*) '      online coarsening of dynamical fields   ln_crs      = ', ln_crs
+         WRITE(numout,*)  
+      ENDIF
+      !
+      IF ( (      ln_RK3 .AND. .NOT.ln_MLF ) .OR.   &
+         & ( .NOT.ln_RK3 .AND.      ln_MLF ) ) THEN
+         IF( ln_RK3 .AND. lwp )   WRITE(numout,*)'   ==>>>   a RK3 time-stepping scheme is used'
+         IF( ln_MLF .AND. lwp )   WRITE(numout,*)'   ==>>>   a MLF time-stepping scheme is used'
+      ELSE
+         CALL ctl_stop( 'dom_nam: select one and only one time stepping scheme')
+      ENDIF
       !
       REWIND( numnam_ref )              ! Namelist namrun in reference namelist : Parameters of the run
@@ -315,4 +346,5 @@
       !
       IF(lwp) THEN                  ! control print
+         WRITE(numout,*)
          WRITE(numout,*) '   Namelist : namrun   ---   run parameters'
          WRITE(numout,*) '      Assimilation cycle              nn_no           = ', nn_no
@@ -330,5 +362,5 @@
          WRITE(numout,*) '      initial time of day in hhmm     nn_time0        = ', nn_time0
          WRITE(numout,*) '      leap year calendar (0/1)        nn_leapy        = ', nn_leapy
-         WRITE(numout,*) '      initial state output            nn_istate       = ', nn_istate
+         WRITE(numout,*) '      output the initial state        ln_istate       = ', ln_istate
          IF( ln_rst_list ) THEN
             WRITE(numout,*) '      list of restart dump times      nn_stocklist    =', nn_stocklist
@@ -357,15 +389,17 @@
       ndate0 = nn_date0
       nleapy = nn_leapy
-      ninist = nn_istate
       nstock = nn_stock
       nstocklist = nn_stocklist
       nwrite = nn_write
-      IF( ln_rstart ) THEN       ! restart : set 1st time-step scheme (LF or forward) 
-         l_1st_euler = ln_1st_euler
-      ELSE                       ! start from rest : always an Euler scheme for the 1st time-step
-         IF(lwp) WRITE(numout,*)  
-         IF(lwp) WRITE(numout,*)'   ==>>>   Start from rest (ln_rstart=F)'
-         IF(lwp) WRITE(numout,*)'           an Euler initial time step is used '   
-         l_1st_euler = .TRUE.
+      
+      IF( ln_MLF ) THEN       ! Leap-Frog only
+         IF( ln_rstart ) THEN       ! restart : set 1st time-step scheme (LF or forward) 
+            l_1st_euler = ln_1st_euler
+         ELSE                       ! start from rest : always an Euler scheme for the 1st time-step
+            IF(lwp) WRITE(numout,*)  
+            IF(lwp) WRITE(numout,*)'   ==>>>   Start from rest (ln_rstart=F)'
+            IF(lwp) WRITE(numout,*)'           an Euler initial time step is used '   
+            l_1st_euler = .TRUE.
+         ENDIF
       ENDIF
       !                             ! control of output frequency
@@ -399,27 +433,7 @@
       ENDIF
 #endif
-
-      REWIND( numnam_ref )              ! Namelist namdom in reference namelist : space & time domain (bathymetry, mesh, timestep)
-      READ  ( numnam_ref, namdom, IOSTAT = ios, ERR = 903)
-903   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namdom in reference namelist', lwp )
-      REWIND( numnam_cfg )              ! Namelist namdom in configuration namelist : space & time domain (bathymetry, mesh, timestep)
-      READ  ( numnam_cfg, namdom, IOSTAT = ios, ERR = 904 )
-904   IF( ios >  0 )   CALL ctl_nam ( ios , 'namdom in configuration namelist', lwp )
-      IF(lwm) WRITE( numond, namdom )
-      !
-      IF(lwp) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) '   Namelist : namdom   ---   space & time domain'
-         WRITE(numout,*) '      linear free surface (=T)                ln_linssh   = ', ln_linssh
-         WRITE(numout,*) '      create mesh/mask file                   ln_meshmask = ', ln_meshmask
-         WRITE(numout,*) '      treshold to open the isf cavity         rn_isfhmin  = ', rn_isfhmin, ' [m]'
-         WRITE(numout,*) '      ocean time step                         rn_dt       = ', rn_dt
-         WRITE(numout,*) '      asselin time filter parameter           rn_atfp     = ', rn_atfp
-         WRITE(numout,*) '      online coarsening of dynamical fields   ln_crs      = ', ln_crs
-      ENDIF
-      !
-      IF( TRIM(Agrif_CFixed()) == '0' ) THEN
+      !
+      IF( TRIM(Agrif_CFixed()) == '0' ) THEN    !set output file type for XIOS based on NEMO namelist 
          lrxios = ln_xios_read.AND.ln_rstart
-!set output file type for XIOS based on NEMO namelist 
          IF (nn_wxios > 0) lwxios = .TRUE. 
          nxioso = nn_wxios
@@ -553,6 +567,6 @@
             CALL iom_getatt( inum, 'cn_cfg', cd_cfg )  ! returns   !  if not found
             CALL iom_getatt( inum, 'nn_cfg', kk_cfg )  ! returns -999 if not found
-            IF( TRIM(cd_cfg) == '!') cd_cfg = 'UNKNOWN'
-            IF( kk_cfg == -999     ) kk_cfg = -9999999
+            IF( TRIM(cd_cfg) == '!')   cd_cfg = 'UNKNOWN'
+            IF( kk_cfg == -999     )   kk_cfg = -9999999
          ENDIF
          !
@@ -701,5 +715,5 @@
       !
    END SUBROUTINE cfg_write
-
+   
    !!======================================================================
 END MODULE domain
Index: /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/dommsk.F90
===================================================================
--- /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/dommsk.F90	(revision 10000)
+++ /NEMO/branches/2018/dev_r9838_ENHANCE04_RK3/src/OCE/DOM/dommsk.F90	(revision 10001)
@@ -202,4 +202,5 @@
       ssumask(:,:) = MAXVAL( umask(:,:,:), DIM=3 )
       ssvmask(:,:) = MAXVAL( vmask(:,:,:), DIM=3 )
+      ssfmask(:,:) = MAXVAL( fmask(:,:,:), DIM=3 )
 
 
